<?php
if (!defined('ABSPATH')) exit; // Exit if accessed directly.
?>

<!-- Main container for PDFs and preview -->
<div class="aipower-pdfs-container">
    <!-- PDFs table section -->
    <div class="aipower-pdfs-section">
        <!-- Tools wrapper -->
        <div class="aipower-pdfs-tools-wrapper">
            <!-- Search input field -->
            <div class="aipower-pdfs-search-wrapper">
                <input type="text" id="aipower-pdfs-search-input" placeholder="<?php echo esc_attr__('Search PDFs...', 'gpt3-ai-content-generator'); ?>" />
            </div>
            <!-- Replace the existing buttons with the following tools container -->
            <div class="aipower-tools-container">
                <!-- Inline confirmation text for Delete All -->
                <div id="aipower-pdf-confirmation" class="aipower-confirmation" style="display:none;">
                    <span><?php echo esc_html__('Sure?', 'gpt3-ai-content-generator'); ?></span>
                    <span id="aipower-pdf-confirm-yes" class="aipower-confirm-yes"><?php echo esc_html__('Yes', 'gpt3-ai-content-generator'); ?></span>
                </div>
                
                <!-- Tool icon for actions -->
                <span id="aipower-pdf-tools-icon" class="dashicons dashicons-admin-tools" title="<?php echo esc_attr__('Tools to refresh and delete all PDFs', 'gpt3-ai-content-generator'); ?>"></span>

                <!-- Hidden menu for actions -->
                <div id="aipower-pdf-tools-menu" class="aipower-pdf-tools-menu" style="display:none;">
                    <div id="aipower-pdf-refresh" class="aipower-tools-action"><?php echo esc_html__('Refresh', 'gpt3-ai-content-generator'); ?></div>
                    <div id="aipower-pdf-delete-all" class="aipower-tools-action"><?php echo esc_html__('Delete All', 'gpt3-ai-content-generator'); ?></div>
                </div>
            </div>
        </div>

        <!-- Hidden nonce field for AJAX security -->
        <input type="hidden" id="ai-pdfs-nonce" value="<?php echo wp_create_nonce('wpaicg_save_pdf_engine_nonce'); ?>" />

        <!-- Render the PDFs table -->
        <?php
        // Determine the current page from a query parameter or default to 1
        $current_pdf_page = isset($_GET['aipower_pdf_page']) ? intval($_GET['aipower_pdf_page']) : 1;
        echo wp_kses_post(WPAICG\WPAICG_PDFs::aipower_render_pdfs_table($current_pdf_page));
        ?>
    </div>
    <!-- Preview section -->
    <div class="aipower-pdf-preview-section">
        <div id="aipower-pdf-details-container"></div> <!-- Container for displaying the PDF details -->
    </div>
</div>
